// license-header java merge-point
// Generated by: crud/SpringCrudDaoBase.vsl in andromda-spring-cartridge.
package org.andromda.samples.crud.color.crud;

import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.andromda.samples.crud.color.Color;
import org.andromda.samples.crud.color.ColorDao;
import org.andromda.samples.crud.color.ColorImpl;
import org.andromda.samples.crud.flower.Flower;
import org.andromda.samples.crud.flower.FlowerDao;
import org.andromda.samples.crud.flower.FlowerImpl;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Restrictions;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

/**
 * 
 */
public final class ColorManageableDaoBase
    extends HibernateDaoSupport
    implements ColorManageableDao
{
    private ColorDao dao;

    /**
     * @param daoIn
     */
    public void setDao(ColorDao daoIn)
    {
        this.dao = daoIn;
    }

    /**
     * @return dao
     */
    protected ColorDao getDao()
    {
        return this.dao;
    }

    private FlowerDao flowersDao = null;

    /**
     * @param flowersDaoIn
     */
    public void setFlowersDao(FlowerDao flowersDaoIn)
    {
        this.flowersDao = flowersDaoIn;
    }

    /**
     * @return dao FlowerDao
     */
    protected FlowerDao getFlowersDao()
    {
        return this.flowersDao;
    }

    @SuppressWarnings({"unchecked"})
    private Set<Flower> findFlowerByIds(Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(FlowerImpl.class);
            criteria.add(Restrictions.in("id", ids));
            return new HashSet<Flower>(criteria.list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @param name 
     * @param description 
     * @param id 
     * @param flowers 
     * @return entity
     * @see ColorDao#create(Color)
     */
    @SuppressWarnings("cast")
    public Color create(String name, String description, Long id, Long[] flowers)
    {
        final Color entity = new ColorImpl();
        entity.setName(name);
        entity.setDescription(description);
        entity.setId(id);
        @SuppressWarnings("unchecked")
        final Set<Flower> flowersEntities = (flowers != null && flowers.length > 0)
            ? this.findFlowerByIds(flowers)
            : Collections.EMPTY_SET;

        entity.setFlowers(flowersEntities);


        return (Color)this.getDao().create(entity);
    }

    /**
     * @param id
     * @return entity
     * @see ColorDao#load(Long)
     */
    public Color readById(Long id)
    {
        return getDao().load(id);
    }

    /**
     * @param name 
     * @param description 
     * @param id 
     * @param flowers 
     * @return List<Color>
     */
    @SuppressWarnings("unchecked")
    public List<Color> read(String name, String description, Long id, Long[] flowers)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(ColorImpl.class);

            if (name != null)
            {
                criteria.add(Restrictions.ilike("name", name, MatchMode.START));
            }
            if (description != null)
            {
                criteria.add(Restrictions.ilike("description", description, MatchMode.START));
            }
            if (id != null)
            {
                criteria.add(Restrictions.eq("id", id));
            }
            if (flowers != null && flowers.length > 0)
            {
                criteria.createCriteria("flowers").add(Restrictions.in("id", flowers));
            }
            criteria.setResultTransformer(Criteria.DISTINCT_ROOT_ENTITY);
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @return criteria.list()
     */
    @SuppressWarnings("unchecked")
    public List<Color> readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(ColorImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @return backingLists Map<String,Object>
     */
    public Map<String,Object> readBackingLists()
    {
        final Map<String,Object> lists = new HashMap<String,Object>();
        final Session session = this.getSession();

        try
        {
            // Put the manageableAssociationEnds in the session query
            lists.put("flowers", session.createQuery("select item.id, item.name from FlowerImpl item order by item.name").list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    /**
     * @param name 
     * @param description 
     * @param id 
     * @param flowers 
     * @return getDao().update(entity)
     * @see ColorDao#update(Color)
     */
    public Color update(String name, String description, Long id, Long[] flowers)
    {
        final Color entity = this.getDao().load(id);

        entity.setName(name);
        entity.setDescription(description);
        @SuppressWarnings("unchecked")
        final Set<Flower> flowersEntities = (flowers != null && flowers.length > 0)
            ? this.findFlowerByIds(flowers)
            : Collections.EMPTY_SET;

        entity.getFlowers().clear();
        entity.getFlowers().addAll(flowersEntities);


        this.getDao().update(entity);
        return entity;
    }


    /**
     * @param ids
     */
    public void delete(Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final Query queryObject =
                session.createQuery("delete ColorImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }
}