// license-header java merge-point
// Generated by: crud/SpringCrudServiceBase.vsl in andromda-spring-cartridge.
package org.andromda.samples.crud.color.crud;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.andromda.samples.crud.color.Color;
import org.andromda.samples.crud.flower.Flower;

/**
 *
 */
public final class ColorManageableServiceBase
    implements ColorManageableService
{
    private ColorManageableDao dao;

    /**
     * @param daoIn
     */
    public void setDao(ColorManageableDao daoIn)
    {
        this.dao = daoIn;
    }

    /**
     * @return dao
     */
    protected ColorManageableDao getDao()
    {
        return this.dao;
    }

    /**
     * @param name 
     * @param description 
     * @param id 
     * @param flowers 
     * @return ColorValueObject
     * @throws Exception
     * @see org.andromda.samples.crud.color.ColorDao#create
     */
    public ColorValueObject create(String name, String description, Long id, Long[] flowers)
        throws Exception
    {
        if (name == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.color.crud.ColorManageableService.create(String name, String description, Long id, Long[] flowers) - 'name' can not be null");
        }

        return toValueObject(this.dao.create(name, description, id, flowers));
    }

    /**
     * @param id
     * @return ColorValueObject
     * @throws Exception
     * @see ColorManageableService#readById(Long)
     */
    public ColorValueObject readById(Long id)
        throws Exception
    {
        return toValueObject(this.dao.readById(id));
    }

    /**
     * @param name 
     * @param description 
     * @param id 
     * @param flowers 
     * @return toValueObjects(dao.read())
     * @throws Exception
     * @see ColorManageableService#read
     */
    public List<ColorValueObject> read(String name, String description, Long id, Long[] flowers)
        throws Exception
    {
        return toValueObjects(this.dao.read(name, description, id, flowers));
    }

    /**
     * @return toValueObjects(dao.readAll())
     * @throws Exception
     */
    public List<ColorValueObject> readAll()
        throws Exception
    {
        return toValueObjects(this.dao.readAll());
    }

    /**
     * @return Map<String,?> getDao().readBackingLists()
     * @throws Exception
     * @see ColorManageableDao#readBackingLists
     */
    public Map<String,?> readBackingLists()
        throws Exception
    {
        return getDao().readBackingLists();
    }

    /**
     * @param name 
     * @param description 
     * @param id 
     * @param flowers 
     * @return toValueObject(this.dao.update(name, description, id, flowers))
     * @throws Exception
     * @see ColorManageableDao#update
     */
    public ColorValueObject update(String name, String description, Long id, Long[] flowers)
        throws Exception
    {
        if (name == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.color.crud.ColorManageableService.update(String name, String description, Long id, Long[] flowers) - 'name' can not be null");
        }

        return toValueObject(this.dao.update(name, description, id, flowers));
    }

    /**
     * @param ids
     * @throws Exception
     * @see ColorManageableService#delete(Long[])
     */
    public void delete(Long[] ids)
        throws Exception
    {
        if (ids == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.color.crud.ColorManageableService.delete(Long[] ids) - 'ids' can not be null");
        }

        this.dao.delete(ids);
    }

    private static List<ColorValueObject> toValueObjects(Collection<Color> entities)
    {
        final List<ColorValueObject> list = new ArrayList<ColorValueObject>();

        for (Iterator<Color> iterator = entities.iterator(); iterator.hasNext();)
        {
            list.add(toValueObject(iterator.next()));
        }

        return list;
    }

    private static ColorValueObject toValueObject(Color entity)
    {
        final ColorValueObject valueObject = new ColorValueObject();

        valueObject.setName(entity.getName());
        valueObject.setDescription(entity.getDescription());
        valueObject.setId(entity.getId());

        final Collection<Flower> flowers = entity.getFlowers();
        if (flowers == null || flowers.isEmpty())
        {
            valueObject.setFlowers(null);
            valueObject.setFlowersLabels(null);
        }
        else
        {
            final Long[] values = new Long[flowers.size()];
            final String[] labels = new String[flowers.size()];
            int counter = 0;
            for (final Iterator<Flower> iterator = flowers.iterator(); iterator.hasNext();counter++)
            {
                final Flower element = iterator.next();
                values[counter] = element.getId();
                labels[counter] = element.getName();
            }
            valueObject.setFlowers(values);
            valueObject.setFlowersLabels(labels);
        }

        return valueObject;
    }
}