// license-header java merge-point
// Generated by: crud/SpringCrudDaoBase.vsl in andromda-spring-cartridge.
package org.andromda.samples.crud.flower.crud;

import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.andromda.samples.crud.color.Color;
import org.andromda.samples.crud.color.ColorDao;
import org.andromda.samples.crud.color.ColorImpl;
import org.andromda.samples.crud.flower.Flower;
import org.andromda.samples.crud.flower.FlowerDao;
import org.andromda.samples.crud.flower.FlowerImpl;
import org.andromda.samples.crud.garden.Garden;
import org.andromda.samples.crud.garden.GardenDao;
import org.andromda.samples.crud.garden.GardenImpl;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Restrictions;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

/**
 * 
 */
public final class FlowerManageableDaoBase
    extends HibernateDaoSupport
    implements FlowerManageableDao
{
    private FlowerDao dao;

    /**
     * @param daoIn
     */
    public void setDao(FlowerDao daoIn)
    {
        this.dao = daoIn;
    }

    /**
     * @return dao
     */
    protected FlowerDao getDao()
    {
        return this.dao;
    }

    private GardenDao gardenDao = null;

    /**
     * @param gardenDaoIn
     */
    public void setGardenDao(GardenDao gardenDaoIn)
    {
        this.gardenDao = gardenDaoIn;
    }

    /**
     * @return dao GardenDao
     */
    protected GardenDao getGardenDao()
    {
        return this.gardenDao;
    }

    private ColorDao colorsDao = null;

    /**
     * @param colorsDaoIn
     */
    public void setColorsDao(ColorDao colorsDaoIn)
    {
        this.colorsDao = colorsDaoIn;
    }

    /**
     * @return dao ColorDao
     */
    protected ColorDao getColorsDao()
    {
        return this.colorsDao;
    }

    @SuppressWarnings({"unchecked"})
    private Set<Garden> findGardenByIds(Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(GardenImpl.class);
            criteria.add(Restrictions.in("id", ids));
            return new HashSet<Garden>(criteria.list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    @SuppressWarnings({"unchecked"})
    private Set<Color> findColorByIds(Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(ColorImpl.class);
            criteria.add(Restrictions.in("id", ids));
            return new HashSet<Color>(criteria.list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @param smellsBad 
     * @param name 
     * @param description 
     * @param picture 
     * @param id 
     * @param garden 
     * @param colors 
     * @return entity
     * @see FlowerDao#create(Flower)
     */
    @SuppressWarnings("cast")
    public Flower create(boolean smellsBad, String name, String description, byte[] picture, Long id, Long garden, Long[] colors)
    {
        final Flower entity = new FlowerImpl();
        entity.setSmellsBad(smellsBad);
        entity.setName(name);
        entity.setDescription(description);
        entity.setPicture(picture);
        entity.setId(id);
        Garden gardenEntity = null;
        if (garden != null)
        {
            gardenEntity = (Garden)getGardenDao().load(garden);
        }

        entity.setGarden(gardenEntity);

        @SuppressWarnings("unchecked")
        final Set<Color> colorsEntities = (colors != null && colors.length > 0)
            ? this.findColorByIds(colors)
            : Collections.EMPTY_SET;

        entity.setColors(colorsEntities);


        return (Flower)this.getDao().create(entity);
    }

    /**
     * @param id
     * @return entity
     * @see FlowerDao#load(Long)
     */
    public Flower readById(Long id)
    {
        return getDao().load(id);
    }

    /**
     * @param smellsBad 
     * @param name 
     * @param description 
     * @param picture 
     * @param id 
     * @param garden 
     * @param colors 
     * @return List<Flower>
     */
    @SuppressWarnings("unchecked")
    public List<Flower> read(Boolean smellsBad, String name, String description, byte[] picture, Long id, Long garden, Long[] colors)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(FlowerImpl.class);

            if (smellsBad != null)
            {
                criteria.add(Restrictions.eq("smellsBad", smellsBad.booleanValue()));
            }
            if (name != null)
            {
                criteria.add(Restrictions.ilike("name", name, MatchMode.START));
            }
            if (description != null)
            {
                criteria.add(Restrictions.ilike("description", description, MatchMode.START));
            }
            if (picture != null)
            {
                criteria.add(Restrictions.eq("picture", picture));
            }
            if (id != null)
            {
                criteria.add(Restrictions.eq("id", id));
            }
            if (garden != null)
            {
                criteria.createCriteria("garden").add(Restrictions.eq("id", garden));
            }
            if (colors != null && colors.length > 0)
            {
                criteria.createCriteria("colors").add(Restrictions.in("id", colors));
            }
            criteria.setResultTransformer(Criteria.DISTINCT_ROOT_ENTITY);
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @return criteria.list()
     */
    @SuppressWarnings("unchecked")
    public List<Flower> readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(FlowerImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public byte[] getPicture(Long id)
    {
        try
        {
            byte[] value = null;

            final Query queryObject = super.getSession(false).createQuery("select entity.picture from FlowerImpl as entity where entity.id = :id");
            queryObject.setParameter("id", id);
            final Iterator iterator = queryObject.iterate();
            if (iterator.hasNext())
            {
                value = (byte[])iterator.next();
            }

            return value;
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @return backingLists Map<String,Object>
     */
    public Map<String,Object> readBackingLists()
    {
        final Map<String,Object> lists = new HashMap<String,Object>();
        final Session session = this.getSession();

        try
        {
            // Put the manageableAssociationEnds in the session query
            lists.put("garden", session.createQuery("select item.id, item.code from GardenImpl item order by item.code").list());
            lists.put("colors", session.createQuery("select item.id, item.name from ColorImpl item order by item.name").list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    /**
     * @param smellsBad 
     * @param name 
     * @param description 
     * @param picture 
     * @param id 
     * @param garden 
     * @param colors 
     * @return getDao().update(entity)
     * @see FlowerDao#update(Flower)
     */
    public Flower update(boolean smellsBad, String name, String description, byte[] picture, Long id, Long garden, Long[] colors)
    {
        final Flower entity = this.getDao().load(id);

        entity.setSmellsBad(smellsBad);
        entity.setName(name);
        entity.setDescription(description);
        entity.setPicture(picture);
        Garden gardenEntity = null;
        if (garden != null)
        {
            gardenEntity = getGardenDao().load(garden);
        }

        entity.setGarden(gardenEntity);

        @SuppressWarnings("unchecked")
        final Set<Color> colorsEntities = (colors != null && colors.length > 0)
            ? this.findColorByIds(colors)
            : Collections.EMPTY_SET;

        entity.getColors().clear();
        entity.getColors().addAll(colorsEntities);


        this.getDao().update(entity);
        return entity;
    }


    /**
     * @param ids
     */
    public void delete(Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final Query queryObject =
                session.createQuery("delete FlowerImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }
}