// license-header java merge-point
// Generated by: crud/SpringCrudServiceBase.vsl in andromda-spring-cartridge.
package org.andromda.samples.crud.flower.crud;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.andromda.samples.crud.color.Color;
import org.andromda.samples.crud.flower.Flower;
import org.andromda.samples.crud.garden.Garden;

/**
 *
 */
public final class FlowerManageableServiceBase
    implements FlowerManageableService
{
    private FlowerManageableDao dao;

    /**
     * @param daoIn
     */
    public void setDao(FlowerManageableDao daoIn)
    {
        this.dao = daoIn;
    }

    /**
     * @return dao
     */
    protected FlowerManageableDao getDao()
    {
        return this.dao;
    }

    /**
     * @param smellsBad 
     * @param name 
     * @param description 
     * @param picture 
     * @param id 
     * @param garden 
     * @param colors 
     * @return FlowerValueObject
     * @throws Exception
     * @see org.andromda.samples.crud.flower.FlowerDao#create
     */
    public FlowerValueObject create(boolean smellsBad, String name, String description, byte[] picture, Long id, Long garden, Long[] colors)
        throws Exception
    {
        if (name == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.flower.crud.FlowerManageableService.create(boolean smellsBad, String name, String description, byte[] picture, Long id, Long garden, Long[] colors) - 'name' can not be null");
        }

        if (garden == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.flower.crud.FlowerManageableService.create(boolean smellsBad, String name, String description, byte[] picture, Long id, Long garden, Long[] colors) - 'garden' can not be null");
        }

        return toValueObject(this.dao.create(smellsBad, name, description, picture, id, garden, colors));
    }

    /**
     * @param id
     * @return FlowerValueObject
     * @throws Exception
     * @see FlowerManageableService#readById(Long)
     */
    public FlowerValueObject readById(Long id)
        throws Exception
    {
        return toValueObject(this.dao.readById(id));
    }

    /**
     * @param smellsBad 
     * @param name 
     * @param description 
     * @param picture 
     * @param id 
     * @param garden 
     * @param colors 
     * @return toValueObjects(dao.read())
     * @throws Exception
     * @see FlowerManageableService#read
     */
    public List<FlowerValueObject> read(Boolean smellsBad, String name, String description, byte[] picture, Long id, Long garden, Long[] colors)
        throws Exception
    {
        return toValueObjects(this.dao.read(smellsBad, name, description, picture, id, garden, colors));
    }

    /**
     * @return toValueObjects(dao.readAll())
     * @throws Exception
     */
    public List<FlowerValueObject> readAll()
        throws Exception
    {
        return toValueObjects(this.dao.readAll());
    }

    /**
     * @param id
     * @return dao.getPicture(id)
     * @throws Exception
     */
    public byte[] getPicture(Long id)
        throws Exception
    {
        if (id == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.flower.crud.FlowerManageableService.getPicture(Long id) - 'id' can not be null");
        }

        return dao.getPicture(id);
    }

    /**
     * @return Map<String,?> getDao().readBackingLists()
     * @throws Exception
     * @see FlowerManageableDao#readBackingLists
     */
    public Map<String,?> readBackingLists()
        throws Exception
    {
        return getDao().readBackingLists();
    }

    /**
     * @param smellsBad 
     * @param name 
     * @param description 
     * @param picture 
     * @param id 
     * @param garden 
     * @param colors 
     * @return toValueObject(this.dao.update(smellsBad, name, description, picture, id, garden, colors))
     * @throws Exception
     * @see FlowerManageableDao#update
     */
    public FlowerValueObject update(boolean smellsBad, String name, String description, byte[] picture, Long id, Long garden, Long[] colors)
        throws Exception
    {
        if (name == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.flower.crud.FlowerManageableService.update(boolean smellsBad, String name, String description, byte[] picture, Long id, Long garden, Long[] colors) - 'name' can not be null");
        }

        if (garden == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.flower.crud.FlowerManageableService.update(boolean smellsBad, String name, String description, byte[] picture, Long id, Long garden, Long[] colors) - 'garden' can not be null");
        }

        return toValueObject(this.dao.update(smellsBad, name, description, picture, id, garden, colors));
    }

    /**
     * @param ids
     * @throws Exception
     * @see FlowerManageableService#delete(Long[])
     */
    public void delete(Long[] ids)
        throws Exception
    {
        if (ids == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.flower.crud.FlowerManageableService.delete(Long[] ids) - 'ids' can not be null");
        }

        this.dao.delete(ids);
    }

    private static List<FlowerValueObject> toValueObjects(Collection<Flower> entities)
    {
        final List<FlowerValueObject> list = new ArrayList<FlowerValueObject>();

        for (Iterator<Flower> iterator = entities.iterator(); iterator.hasNext();)
        {
            list.add(toValueObject(iterator.next()));
        }

        return list;
    }

    private static FlowerValueObject toValueObject(Flower entity)
    {
        final FlowerValueObject valueObject = new FlowerValueObject();

        valueObject.setSmellsBad(entity.isSmellsBad());
        valueObject.setName(entity.getName());
        valueObject.setDescription(entity.getDescription());
        valueObject.setPicture(entity.getPicture());
        valueObject.setId(entity.getId());

        final Garden garden = entity.getGarden();
        if (garden != null)
        {
            valueObject.setGarden(garden.getId());
            valueObject.setGardenLabel(garden.getCode());
        }

        final Collection<Color> colors = entity.getColors();
        if (colors == null || colors.isEmpty())
        {
            valueObject.setColors(null);
            valueObject.setColorsLabels(null);
        }
        else
        {
            final Long[] values = new Long[colors.size()];
            final String[] labels = new String[colors.size()];
            int counter = 0;
            for (final Iterator<Color> iterator = colors.iterator(); iterator.hasNext();counter++)
            {
                final Color element = iterator.next();
                values[counter] = element.getId();
                labels[counter] = element.getName();
            }
            valueObject.setColors(values);
            valueObject.setColorsLabels(labels);
        }

        return valueObject;
    }
}