// license-header java merge-point
// Generated by: crud/SpringCrudDaoBase.vsl in andromda-spring-cartridge.
package org.andromda.samples.crud.garden.crud;

import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.andromda.samples.crud.flower.Flower;
import org.andromda.samples.crud.flower.FlowerDao;
import org.andromda.samples.crud.flower.FlowerImpl;
import org.andromda.samples.crud.garden.Garden;
import org.andromda.samples.crud.garden.GardenDao;
import org.andromda.samples.crud.garden.GardenImpl;
import org.andromda.samples.crud.home.Home;
import org.andromda.samples.crud.home.HomeDao;
import org.andromda.samples.crud.home.HomeImpl;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Restrictions;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

/**
 * 
 */
public final class GardenManageableDaoBase
    extends HibernateDaoSupport
    implements GardenManageableDao
{
    private GardenDao dao;

    /**
     * @param daoIn
     */
    public void setDao(GardenDao daoIn)
    {
        this.dao = daoIn;
    }

    /**
     * @return dao
     */
    protected GardenDao getDao()
    {
        return this.dao;
    }

    private HomeDao homeDao = null;

    /**
     * @param homeDaoIn
     */
    public void setHomeDao(HomeDao homeDaoIn)
    {
        this.homeDao = homeDaoIn;
    }

    /**
     * @return dao HomeDao
     */
    protected HomeDao getHomeDao()
    {
        return this.homeDao;
    }

    private FlowerDao flowersDao = null;

    /**
     * @param flowersDaoIn
     */
    public void setFlowersDao(FlowerDao flowersDaoIn)
    {
        this.flowersDao = flowersDaoIn;
    }

    /**
     * @return dao FlowerDao
     */
    protected FlowerDao getFlowersDao()
    {
        return this.flowersDao;
    }

    @SuppressWarnings({"unchecked"})
    private Set<Home> findHomeByIds(Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(HomeImpl.class);
            criteria.add(Restrictions.in("id", ids));
            return new HashSet<Home>(criteria.list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    @SuppressWarnings({"unchecked"})
    private Set<Flower> findFlowerByIds(Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(FlowerImpl.class);
            criteria.add(Restrictions.in("id", ids));
            return new HashSet<Flower>(criteria.list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @param squareFeet 
     * @param description 
     * @param code 
     * @param id 
     * @param home 
     * @param flowers 
     * @return entity
     * @see GardenDao#create(Garden)
     */
    @SuppressWarnings("cast")
    public Garden create(int squareFeet, String description, String code, Long id, Long home, Long[] flowers)
    {
        final Garden entity = new GardenImpl();
        entity.setSquareFeet(squareFeet);
        entity.setDescription(description);
        entity.setCode(code);
        entity.setId(id);
        Home homeEntity = null;
        if (home != null)
        {
            homeEntity = (Home)getHomeDao().load(home);
        }

        entity.setHome(homeEntity);

        @SuppressWarnings("unchecked")
        final Set<Flower> flowersEntities = (flowers != null && flowers.length > 0)
            ? this.findFlowerByIds(flowers)
            : Collections.EMPTY_SET;

        entity.setFlowers(flowersEntities);


        return (Garden)this.getDao().create(entity);
    }

    /**
     * @param id
     * @return entity
     * @see GardenDao#load(Long)
     */
    public Garden readById(Long id)
    {
        return getDao().load(id);
    }

    /**
     * @param squareFeet 
     * @param description 
     * @param code 
     * @param id 
     * @param home 
     * @param flowers 
     * @return List<Garden>
     */
    @SuppressWarnings("unchecked")
    public List<Garden> read(Integer squareFeet, String description, String code, Long id, Long home, Long[] flowers)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(GardenImpl.class);

            if (squareFeet != null)
            {
                criteria.add(Restrictions.eq("squareFeet", squareFeet));
            }
            if (description != null)
            {
                criteria.add(Restrictions.ilike("description", description, MatchMode.START));
            }
            if (code != null)
            {
                criteria.add(Restrictions.ilike("code", code, MatchMode.START));
            }
            if (id != null)
            {
                criteria.add(Restrictions.eq("id", id));
            }
            if (home != null)
            {
                criteria.createCriteria("home").add(Restrictions.eq("id", home));
            }
            if (flowers != null && flowers.length > 0)
            {
                criteria.createCriteria("flowers").add(Restrictions.in("id", flowers));
            }
            criteria.setResultTransformer(Criteria.DISTINCT_ROOT_ENTITY);
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @return criteria.list()
     */
    @SuppressWarnings("unchecked")
    public List<Garden> readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(GardenImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @return backingLists Map<String,Object>
     */
    public Map<String,Object> readBackingLists()
    {
        final Map<String,Object> lists = new HashMap<String,Object>();
        final Session session = this.getSession();

        try
        {
            // Put the manageableAssociationEnds in the session query
            lists.put("home", session.createQuery("select item.id, item.name from HomeImpl item order by item.name").list());
            lists.put("flowers", session.createQuery("select item.id, item.name from FlowerImpl item order by item.name").list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    /**
     * @param squareFeet 
     * @param description 
     * @param code 
     * @param id 
     * @param home 
     * @param flowers 
     * @return getDao().update(entity)
     * @see GardenDao#update(Garden)
     */
    public Garden update(int squareFeet, String description, String code, Long id, Long home, Long[] flowers)
    {
        final Garden entity = this.getDao().load(id);

        entity.setSquareFeet(squareFeet);
        entity.setDescription(description);
        entity.setCode(code);
        Home homeEntity = null;
        if (home != null)
        {
            homeEntity = getHomeDao().load(home);
        }

        entity.setHome(homeEntity);

        @SuppressWarnings("unchecked")
        final Set<Flower> flowersEntities = (flowers != null && flowers.length > 0)
            ? this.findFlowerByIds(flowers)
            : Collections.EMPTY_SET;

        entity.getFlowers().clear();
        entity.getFlowers().addAll(flowersEntities);


        this.getDao().update(entity);
        return entity;
    }


    /**
     * @param ids
     */
    public void delete(Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final Query queryObject =
                session.createQuery("delete GardenImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }
}