// license-header java merge-point
// Generated by: crud/SpringCrudServiceBase.vsl in andromda-spring-cartridge.
package org.andromda.samples.crud.garden.crud;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.andromda.samples.crud.flower.Flower;
import org.andromda.samples.crud.garden.Garden;
import org.andromda.samples.crud.home.Home;

/**
 *
 */
public final class GardenManageableServiceBase
    implements GardenManageableService
{
    private GardenManageableDao dao;

    /**
     * @param daoIn
     */
    public void setDao(GardenManageableDao daoIn)
    {
        this.dao = daoIn;
    }

    /**
     * @return dao
     */
    protected GardenManageableDao getDao()
    {
        return this.dao;
    }

    /**
     * @param squareFeet 
     * @param description 
     * @param code 
     * @param id 
     * @param home 
     * @param flowers 
     * @return GardenValueObject
     * @throws Exception
     * @see org.andromda.samples.crud.garden.GardenDao#create
     */
    public GardenValueObject create(int squareFeet, String description, String code, Long id, Long home, Long[] flowers)
        throws Exception
    {
        if (code == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.garden.crud.GardenManageableService.create(int squareFeet, String description, String code, Long id, Long home, Long[] flowers) - 'code' can not be null");
        }

        if (home == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.garden.crud.GardenManageableService.create(int squareFeet, String description, String code, Long id, Long home, Long[] flowers) - 'home' can not be null");
        }

        return toValueObject(this.dao.create(squareFeet, description, code, id, home, flowers));
    }

    /**
     * @param id
     * @return GardenValueObject
     * @throws Exception
     * @see GardenManageableService#readById(Long)
     */
    public GardenValueObject readById(Long id)
        throws Exception
    {
        return toValueObject(this.dao.readById(id));
    }

    /**
     * @param squareFeet 
     * @param description 
     * @param code 
     * @param id 
     * @param home 
     * @param flowers 
     * @return toValueObjects(dao.read())
     * @throws Exception
     * @see GardenManageableService#read
     */
    public List<GardenValueObject> read(Integer squareFeet, String description, String code, Long id, Long home, Long[] flowers)
        throws Exception
    {
        return toValueObjects(this.dao.read(squareFeet, description, code, id, home, flowers));
    }

    /**
     * @return toValueObjects(dao.readAll())
     * @throws Exception
     */
    public List<GardenValueObject> readAll()
        throws Exception
    {
        return toValueObjects(this.dao.readAll());
    }

    /**
     * @return Map<String,?> getDao().readBackingLists()
     * @throws Exception
     * @see GardenManageableDao#readBackingLists
     */
    public Map<String,?> readBackingLists()
        throws Exception
    {
        return getDao().readBackingLists();
    }

    /**
     * @param squareFeet 
     * @param description 
     * @param code 
     * @param id 
     * @param home 
     * @param flowers 
     * @return toValueObject(this.dao.update(squareFeet, description, code, id, home, flowers))
     * @throws Exception
     * @see GardenManageableDao#update
     */
    public GardenValueObject update(int squareFeet, String description, String code, Long id, Long home, Long[] flowers)
        throws Exception
    {
        if (code == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.garden.crud.GardenManageableService.update(int squareFeet, String description, String code, Long id, Long home, Long[] flowers) - 'code' can not be null");
        }

        if (home == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.garden.crud.GardenManageableService.update(int squareFeet, String description, String code, Long id, Long home, Long[] flowers) - 'home' can not be null");
        }

        return toValueObject(this.dao.update(squareFeet, description, code, id, home, flowers));
    }

    /**
     * @param ids
     * @throws Exception
     * @see GardenManageableService#delete(Long[])
     */
    public void delete(Long[] ids)
        throws Exception
    {
        if (ids == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.garden.crud.GardenManageableService.delete(Long[] ids) - 'ids' can not be null");
        }

        this.dao.delete(ids);
    }

    private static List<GardenValueObject> toValueObjects(Collection<Garden> entities)
    {
        final List<GardenValueObject> list = new ArrayList<GardenValueObject>();

        for (Iterator<Garden> iterator = entities.iterator(); iterator.hasNext();)
        {
            list.add(toValueObject(iterator.next()));
        }

        return list;
    }

    private static GardenValueObject toValueObject(Garden entity)
    {
        final GardenValueObject valueObject = new GardenValueObject();

        valueObject.setSquareFeet(entity.getSquareFeet());
        valueObject.setDescription(entity.getDescription());
        valueObject.setCode(entity.getCode());
        valueObject.setId(entity.getId());

        final Home home = entity.getHome();
        if (home != null)
        {
            valueObject.setHome(home.getId());
            valueObject.setHomeLabel(home.getName());
        }

        final Collection<Flower> flowers = entity.getFlowers();
        if (flowers == null || flowers.isEmpty())
        {
            valueObject.setFlowers(null);
            valueObject.setFlowersLabels(null);
        }
        else
        {
            final Long[] values = new Long[flowers.size()];
            final String[] labels = new String[flowers.size()];
            int counter = 0;
            for (final Iterator<Flower> iterator = flowers.iterator(); iterator.hasNext();counter++)
            {
                final Flower element = iterator.next();
                values[counter] = element.getId();
                labels[counter] = element.getName();
            }
            valueObject.setFlowers(values);
            valueObject.setFlowersLabels(labels);
        }

        return valueObject;
    }
}