// license-header java merge-point
// Generated by: crud/SpringCrudDaoBase.vsl in andromda-spring-cartridge.
package org.andromda.samples.crud.home.crud;

import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.andromda.samples.crud.garden.Garden;
import org.andromda.samples.crud.garden.GardenDao;
import org.andromda.samples.crud.garden.GardenImpl;
import org.andromda.samples.crud.home.Home;
import org.andromda.samples.crud.home.HomeDao;
import org.andromda.samples.crud.home.HomeImpl;
import org.andromda.samples.crud.home.HomeType;
import org.andromda.samples.crud.room.Room;
import org.andromda.samples.crud.room.RoomDao;
import org.andromda.samples.crud.room.RoomImpl;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Restrictions;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

/**
 * 
 */
public final class HomeManageableDaoBase
    extends HibernateDaoSupport
    implements HomeManageableDao
{
    private HomeDao dao;

    /**
     * @param daoIn
     */
    public void setDao(HomeDao daoIn)
    {
        this.dao = daoIn;
    }

    /**
     * @return dao
     */
    protected HomeDao getDao()
    {
        return this.dao;
    }

    private GardenDao gardensDao = null;

    /**
     * @param gardensDaoIn
     */
    public void setGardensDao(GardenDao gardensDaoIn)
    {
        this.gardensDao = gardensDaoIn;
    }

    /**
     * @return dao GardenDao
     */
    protected GardenDao getGardensDao()
    {
        return this.gardensDao;
    }

    private RoomDao roomsDao = null;

    /**
     * @param roomsDaoIn
     */
    public void setRoomsDao(RoomDao roomsDaoIn)
    {
        this.roomsDao = roomsDaoIn;
    }

    /**
     * @return dao RoomDao
     */
    protected RoomDao getRoomsDao()
    {
        return this.roomsDao;
    }

    @SuppressWarnings({"unchecked"})
    private Set<Garden> findGardenByIds(Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(GardenImpl.class);
            criteria.add(Restrictions.in("id", ids));
            return new HashSet<Garden>(criteria.list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    @SuppressWarnings({"unchecked"})
    private Set<Room> findRoomByIds(Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(RoomImpl.class);
            criteria.add(Restrictions.in("id", ids));
            return new HashSet<Room>(criteria.list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @param style 
     * @param name 
     * @param description 
     * @param constructed 
     * @param id 
     * @param gardens 
     * @param rooms 
     * @return entity
     * @see HomeDao#create(Home)
     */
    @SuppressWarnings("cast")
    public Home create(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms)
    {
        final Home entity = new HomeImpl();
        entity.setStyle(style);
        entity.setName(name);
        entity.setDescription(description);
        entity.setConstructed(constructed);
        entity.setId(id);
        @SuppressWarnings("unchecked")
        final Set<Garden> gardensEntities = (gardens != null && gardens.length > 0)
            ? this.findGardenByIds(gardens)
            : Collections.EMPTY_SET;

        entity.setGardens(gardensEntities);

        @SuppressWarnings("unchecked")
        final Set<Room> roomsEntities = (rooms != null && rooms.length > 0)
            ? this.findRoomByIds(rooms)
            : Collections.EMPTY_SET;

        entity.setRooms(roomsEntities);


        return (Home)this.getDao().create(entity);
    }

    /**
     * @param id
     * @return entity
     * @see HomeDao#load(Long)
     */
    public Home readById(Long id)
    {
        return getDao().load(id);
    }

    /**
     * @param style 
     * @param name 
     * @param description 
     * @param constructed 
     * @param id 
     * @param gardens 
     * @param rooms 
     * @return List<Home>
     */
    @SuppressWarnings("unchecked")
    public List<Home> read(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(HomeImpl.class);

            if (style != null)
            {
                criteria.add(Restrictions.eq("style", style));
            }
            if (name != null)
            {
                criteria.add(Restrictions.ilike("name", name, MatchMode.START));
            }
            if (description != null)
            {
                criteria.add(Restrictions.ilike("description", description, MatchMode.START));
            }
            if (constructed != null)
            {
                // we check whether or not the user supplied time information within this particular date argument
                // if he/she didn't we assume he/she wishes to search in the scope of the entire day
                final Calendar calendar = new GregorianCalendar();
                calendar.setTime(constructed);
                if ( calendar.get(Calendar.HOUR) != 0
                     || calendar.get(Calendar.MINUTE) != 0
                     || calendar.get(Calendar.SECOND) != 0
                     || calendar.get(Calendar.MILLISECOND) != 0 )
                {
                    criteria.add(Restrictions.eq("constructed", constructed));
                }
                else
                {
                    calendar.add(Calendar.DATE, 1);
                    calendar.add(Calendar.MILLISECOND, -1);
                    criteria.add(Restrictions.between("constructed", constructed, calendar.getTime()));
                }
            }
            if (id != null)
            {
                criteria.add(Restrictions.eq("id", id));
            }
            if (gardens != null && gardens.length > 0)
            {
                criteria.createCriteria("gardens").add(Restrictions.in("id", gardens));
            }
            if (rooms != null && rooms.length > 0)
            {
                criteria.createCriteria("rooms").add(Restrictions.in("id", rooms));
            }
            criteria.setResultTransformer(Criteria.DISTINCT_ROOT_ENTITY);
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @return criteria.list()
     */
    @SuppressWarnings("unchecked")
    public List<Home> readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(HomeImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @return backingLists Map<String,Object>
     */
    public Map<String,Object> readBackingLists()
    {
        final Map<String,Object> lists = new HashMap<String,Object>();
        final Session session = this.getSession();

        try
        {
            // Put the manageableAssociationEnds in the session query
            lists.put("gardens", session.createQuery("select item.id, item.code from GardenImpl item order by item.code").list());
            lists.put("rooms", session.createQuery("select item.id, item.name from RoomImpl item order by item.name").list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    /**
     * @param style 
     * @param name 
     * @param description 
     * @param constructed 
     * @param id 
     * @param gardens 
     * @param rooms 
     * @return getDao().update(entity)
     * @see HomeDao#update(Home)
     */
    public Home update(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms)
    {
        final Home entity = this.getDao().load(id);

        entity.setStyle(style);
        entity.setName(name);
        entity.setDescription(description);
        entity.setConstructed(constructed);
        @SuppressWarnings("unchecked")
        final Set<Garden> gardensEntities = (gardens != null && gardens.length > 0)
            ? this.findGardenByIds(gardens)
            : Collections.EMPTY_SET;

        entity.getGardens().clear();
        entity.getGardens().addAll(gardensEntities);

        @SuppressWarnings("unchecked")
        final Set<Room> roomsEntities = (rooms != null && rooms.length > 0)
            ? this.findRoomByIds(rooms)
            : Collections.EMPTY_SET;

        entity.getRooms().clear();
        entity.getRooms().addAll(roomsEntities);


        this.getDao().update(entity);
        return entity;
    }


    /**
     * @param ids
     */
    public void delete(Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final Query queryObject =
                session.createQuery("delete HomeImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }
}