// license-header java merge-point
// Generated by: crud/SpringCrudServiceBase.vsl in andromda-spring-cartridge.
package org.andromda.samples.crud.home.crud;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.andromda.samples.crud.garden.Garden;
import org.andromda.samples.crud.home.Home;
import org.andromda.samples.crud.home.HomeType;
import org.andromda.samples.crud.room.Room;

/**
 *
 */
public final class HomeManageableServiceBase
    implements HomeManageableService
{
    private HomeManageableDao dao;

    /**
     * @param daoIn
     */
    public void setDao(HomeManageableDao daoIn)
    {
        this.dao = daoIn;
    }

    /**
     * @return dao
     */
    protected HomeManageableDao getDao()
    {
        return this.dao;
    }

    /**
     * @param style 
     * @param name 
     * @param description 
     * @param constructed 
     * @param id 
     * @param gardens 
     * @param rooms 
     * @return HomeValueObject
     * @throws Exception
     * @see org.andromda.samples.crud.home.HomeDao#create
     */
    public HomeValueObject create(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms)
        throws Exception
    {
        if (style == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.home.crud.HomeManageableService.create(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms) - 'style' can not be null");
        }

        if (name == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.home.crud.HomeManageableService.create(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms) - 'name' can not be null");
        }

        if (constructed == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.home.crud.HomeManageableService.create(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms) - 'constructed' can not be null");
        }

        return toValueObject(this.dao.create(style, name, description, constructed, id, gardens, rooms));
    }

    /**
     * @param id
     * @return HomeValueObject
     * @throws Exception
     * @see HomeManageableService#readById(Long)
     */
    public HomeValueObject readById(Long id)
        throws Exception
    {
        return toValueObject(this.dao.readById(id));
    }

    /**
     * @param style 
     * @param name 
     * @param description 
     * @param constructed 
     * @param id 
     * @param gardens 
     * @param rooms 
     * @return toValueObjects(dao.read())
     * @throws Exception
     * @see HomeManageableService#read
     */
    public List<HomeValueObject> read(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms)
        throws Exception
    {
        return toValueObjects(this.dao.read(style, name, description, constructed, id, gardens, rooms));
    }

    /**
     * @return toValueObjects(dao.readAll())
     * @throws Exception
     */
    public List<HomeValueObject> readAll()
        throws Exception
    {
        return toValueObjects(this.dao.readAll());
    }

    /**
     * @return Map<String,?> getDao().readBackingLists()
     * @throws Exception
     * @see HomeManageableDao#readBackingLists
     */
    public Map<String,?> readBackingLists()
        throws Exception
    {
        return getDao().readBackingLists();
    }

    /**
     * @param style 
     * @param name 
     * @param description 
     * @param constructed 
     * @param id 
     * @param gardens 
     * @param rooms 
     * @return toValueObject(this.dao.update(style, name, description, constructed, id, gardens, rooms))
     * @throws Exception
     * @see HomeManageableDao#update
     */
    public HomeValueObject update(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms)
        throws Exception
    {
        if (style == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.home.crud.HomeManageableService.update(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms) - 'style' can not be null");
        }

        if (name == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.home.crud.HomeManageableService.update(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms) - 'name' can not be null");
        }

        if (constructed == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.home.crud.HomeManageableService.update(HomeType style, String name, String description, Date constructed, Long id, Long[] gardens, Long[] rooms) - 'constructed' can not be null");
        }

        return toValueObject(this.dao.update(style, name, description, constructed, id, gardens, rooms));
    }

    /**
     * @param ids
     * @throws Exception
     * @see HomeManageableService#delete(Long[])
     */
    public void delete(Long[] ids)
        throws Exception
    {
        if (ids == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.home.crud.HomeManageableService.delete(Long[] ids) - 'ids' can not be null");
        }

        this.dao.delete(ids);
    }

    private static List<HomeValueObject> toValueObjects(Collection<Home> entities)
    {
        final List<HomeValueObject> list = new ArrayList<HomeValueObject>();

        for (Iterator<Home> iterator = entities.iterator(); iterator.hasNext();)
        {
            list.add(toValueObject(iterator.next()));
        }

        return list;
    }

    private static HomeValueObject toValueObject(Home entity)
    {
        final HomeValueObject valueObject = new HomeValueObject();

        valueObject.setStyle(entity.getStyle());
        valueObject.setName(entity.getName());
        valueObject.setDescription(entity.getDescription());
        valueObject.setConstructed(entity.getConstructed());
        valueObject.setId(entity.getId());

        final Collection<Garden> gardens = entity.getGardens();
        if (gardens == null || gardens.isEmpty())
        {
            valueObject.setGardens(null);
            valueObject.setGardensLabels(null);
        }
        else
        {
            final Long[] values = new Long[gardens.size()];
            final String[] labels = new String[gardens.size()];
            int counter = 0;
            for (final Iterator<Garden> iterator = gardens.iterator(); iterator.hasNext();counter++)
            {
                final Garden element = iterator.next();
                values[counter] = element.getId();
                labels[counter] = element.getCode();
            }
            valueObject.setGardens(values);
            valueObject.setGardensLabels(labels);
        }

        final Collection<Room> rooms = entity.getRooms();
        if (rooms == null || rooms.isEmpty())
        {
            valueObject.setRooms(null);
            valueObject.setRoomsLabels(null);
        }
        else
        {
            final Long[] values = new Long[rooms.size()];
            final String[] labels = new String[rooms.size()];
            int counter = 0;
            for (final Iterator<Room> iterator = rooms.iterator(); iterator.hasNext();counter++)
            {
                final Room element = iterator.next();
                values[counter] = element.getId();
                labels[counter] = element.getName();
            }
            valueObject.setRooms(values);
            valueObject.setRoomsLabels(labels);
        }

        return valueObject;
    }
}