// license-header java merge-point
// Generated by: crud/SpringCrudDaoBase.vsl in andromda-spring-cartridge.
package org.andromda.samples.crud.room.crud;

import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.andromda.samples.crud.home.Home;
import org.andromda.samples.crud.home.HomeDao;
import org.andromda.samples.crud.home.HomeImpl;
import org.andromda.samples.crud.room.Room;
import org.andromda.samples.crud.room.RoomDao;
import org.andromda.samples.crud.room.RoomImpl;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Restrictions;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

/**
 * 
 */
public final class RoomManageableDaoBase
    extends HibernateDaoSupport
    implements RoomManageableDao
{
    private RoomDao dao;

    /**
     * @param daoIn
     */
    public void setDao(RoomDao daoIn)
    {
        this.dao = daoIn;
    }

    /**
     * @return dao
     */
    protected RoomDao getDao()
    {
        return this.dao;
    }

    private HomeDao homeDao = null;

    /**
     * @param homeDaoIn
     */
    public void setHomeDao(HomeDao homeDaoIn)
    {
        this.homeDao = homeDaoIn;
    }

    /**
     * @return dao HomeDao
     */
    protected HomeDao getHomeDao()
    {
        return this.homeDao;
    }

    @SuppressWarnings({"unchecked"})
    private Set<Home> findHomeByIds(Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(HomeImpl.class);
            criteria.add(Restrictions.in("id", ids));
            return new HashSet<Home>(criteria.list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @param type 
     * @param squareFeet 
     * @param name 
     * @param description 
     * @param id 
     * @param home 
     * @return entity
     * @see RoomDao#create(Room)
     */
    @SuppressWarnings("cast")
    public Room create(String type, int squareFeet, String name, String description, Long id, Long home)
    {
        final Room entity = new RoomImpl();
        entity.setType(type);
        entity.setSquareFeet(squareFeet);
        entity.setName(name);
        entity.setDescription(description);
        entity.setId(id);
        Home homeEntity = null;
        if (home != null)
        {
            homeEntity = (Home)getHomeDao().load(home);
        }

        entity.setHome(homeEntity);


        return (Room)this.getDao().create(entity);
    }

    /**
     * @param id
     * @return entity
     * @see RoomDao#load(Long)
     */
    public Room readById(Long id)
    {
        return getDao().load(id);
    }

    /**
     * @param type 
     * @param squareFeet 
     * @param name 
     * @param description 
     * @param id 
     * @param home 
     * @return List<Room>
     */
    @SuppressWarnings("unchecked")
    public List<Room> read(String type, Integer squareFeet, String name, String description, Long id, Long home)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(RoomImpl.class);

            if (type != null)
            {
                criteria.add(Restrictions.ilike("type", type, MatchMode.START));
            }
            if (squareFeet != null)
            {
                criteria.add(Restrictions.eq("squareFeet", squareFeet));
            }
            if (name != null)
            {
                criteria.add(Restrictions.ilike("name", name, MatchMode.START));
            }
            if (description != null)
            {
                criteria.add(Restrictions.ilike("description", description, MatchMode.START));
            }
            if (id != null)
            {
                criteria.add(Restrictions.eq("id", id));
            }
            if (home != null)
            {
                criteria.createCriteria("home").add(Restrictions.eq("id", home));
            }
            criteria.setResultTransformer(Criteria.DISTINCT_ROOT_ENTITY);
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @return criteria.list()
     */
    @SuppressWarnings("unchecked")
    public List<Room> readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(RoomImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    /**
     * @return backingLists Map<String,Object>
     */
    public Map<String,Object> readBackingLists()
    {
        final Map<String,Object> lists = new HashMap<String,Object>();
        final Session session = this.getSession();

        try
        {
            // Put the manageableAssociationEnds in the session query
            lists.put("home", session.createQuery("select item.id, item.name from HomeImpl item order by item.name").list());
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    /**
     * @param type 
     * @param squareFeet 
     * @param name 
     * @param description 
     * @param id 
     * @param home 
     * @return getDao().update(entity)
     * @see RoomDao#update(Room)
     */
    public Room update(String type, int squareFeet, String name, String description, Long id, Long home)
    {
        final Room entity = this.getDao().load(id);

        entity.setType(type);
        entity.setSquareFeet(squareFeet);
        entity.setName(name);
        entity.setDescription(description);
        Home homeEntity = null;
        if (home != null)
        {
            homeEntity = getHomeDao().load(home);
        }

        entity.setHome(homeEntity);


        this.getDao().update(entity);
        return entity;
    }


    /**
     * @param ids
     */
    public void delete(Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final Query queryObject =
                session.createQuery("delete RoomImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }
}