// license-header java merge-point
// Generated by: crud/SpringCrudServiceBase.vsl in andromda-spring-cartridge.
package org.andromda.samples.crud.room.crud;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.andromda.samples.crud.home.Home;
import org.andromda.samples.crud.room.Room;

/**
 *
 */
public final class RoomManageableServiceBase
    implements RoomManageableService
{
    private RoomManageableDao dao;

    /**
     * @param daoIn
     */
    public void setDao(RoomManageableDao daoIn)
    {
        this.dao = daoIn;
    }

    /**
     * @return dao
     */
    protected RoomManageableDao getDao()
    {
        return this.dao;
    }

    /**
     * @param type 
     * @param squareFeet 
     * @param name 
     * @param description 
     * @param id 
     * @param home 
     * @return RoomValueObject
     * @throws Exception
     * @see org.andromda.samples.crud.room.RoomDao#create
     */
    public RoomValueObject create(String type, int squareFeet, String name, String description, Long id, Long home)
        throws Exception
    {
        if (type == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.room.crud.RoomManageableService.create(String type, int squareFeet, String name, String description, Long id, Long home) - 'type' can not be null");
        }

        if (name == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.room.crud.RoomManageableService.create(String type, int squareFeet, String name, String description, Long id, Long home) - 'name' can not be null");
        }

        if (home == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.room.crud.RoomManageableService.create(String type, int squareFeet, String name, String description, Long id, Long home) - 'home' can not be null");
        }

        return toValueObject(this.dao.create(type, squareFeet, name, description, id, home));
    }

    /**
     * @param id
     * @return RoomValueObject
     * @throws Exception
     * @see RoomManageableService#readById(Long)
     */
    public RoomValueObject readById(Long id)
        throws Exception
    {
        return toValueObject(this.dao.readById(id));
    }

    /**
     * @param type 
     * @param squareFeet 
     * @param name 
     * @param description 
     * @param id 
     * @param home 
     * @return toValueObjects(dao.read())
     * @throws Exception
     * @see RoomManageableService#read
     */
    public List<RoomValueObject> read(String type, Integer squareFeet, String name, String description, Long id, Long home)
        throws Exception
    {
        return toValueObjects(this.dao.read(type, squareFeet, name, description, id, home));
    }

    /**
     * @return toValueObjects(dao.readAll())
     * @throws Exception
     */
    public List<RoomValueObject> readAll()
        throws Exception
    {
        return toValueObjects(this.dao.readAll());
    }

    /**
     * @return Map<String,?> getDao().readBackingLists()
     * @throws Exception
     * @see RoomManageableDao#readBackingLists
     */
    public Map<String,?> readBackingLists()
        throws Exception
    {
        return getDao().readBackingLists();
    }

    /**
     * @param type 
     * @param squareFeet 
     * @param name 
     * @param description 
     * @param id 
     * @param home 
     * @return toValueObject(this.dao.update(type, squareFeet, name, description, id, home))
     * @throws Exception
     * @see RoomManageableDao#update
     */
    public RoomValueObject update(String type, int squareFeet, String name, String description, Long id, Long home)
        throws Exception
    {
        if (type == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.room.crud.RoomManageableService.update(String type, int squareFeet, String name, String description, Long id, Long home) - 'type' can not be null");
        }

        if (name == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.room.crud.RoomManageableService.update(String type, int squareFeet, String name, String description, Long id, Long home) - 'name' can not be null");
        }

        if (home == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.room.crud.RoomManageableService.update(String type, int squareFeet, String name, String description, Long id, Long home) - 'home' can not be null");
        }

        return toValueObject(this.dao.update(type, squareFeet, name, description, id, home));
    }

    /**
     * @param ids
     * @throws Exception
     * @see RoomManageableService#delete(Long[])
     */
    public void delete(Long[] ids)
        throws Exception
    {
        if (ids == null)
        {
            throw new IllegalArgumentException(
                "org.andromda.samples.crud.room.crud.RoomManageableService.delete(Long[] ids) - 'ids' can not be null");
        }

        this.dao.delete(ids);
    }

    private static List<RoomValueObject> toValueObjects(Collection<Room> entities)
    {
        final List<RoomValueObject> list = new ArrayList<RoomValueObject>();

        for (Iterator<Room> iterator = entities.iterator(); iterator.hasNext();)
        {
            list.add(toValueObject(iterator.next()));
        }

        return list;
    }

    private static RoomValueObject toValueObject(Room entity)
    {
        final RoomValueObject valueObject = new RoomValueObject();

        valueObject.setType(entity.getType());
        valueObject.setSquareFeet(entity.getSquareFeet());
        valueObject.setName(entity.getName());
        valueObject.setDescription(entity.getDescription());
        valueObject.setId(entity.getId());

        final Home home = entity.getHome();
        if (home != null)
        {
            valueObject.setHome(home.getId());
            valueObject.setHomeLabel(home.getName());
        }

        return valueObject;
    }
}